diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerInput.java b/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
index b9433474a..77ed4c282 100644
--- a/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerInput.java
@@ -199,7 +199,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "L2";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "ZL";
                     default:
                         return "LT";
@@ -210,7 +210,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "R2";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "ZR";
                     default:
                         return "RT";
@@ -228,7 +228,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "X";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "B";
                     default:
                         return "A";
@@ -239,7 +239,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "O";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "A";
                     default:
                         return "B";
@@ -250,7 +250,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "□";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "Y";
                     default:
                         return "X";
@@ -261,33 +261,33 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "△";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "X";
                     default:
                         return "Y";
                 }
             case GLFW.GLFW_GAMEPAD_BUTTON_BACK:
                 switch (controllerType) {
-                    case XBOXONE:
+                    case XBOX_ONE:
                         return "View";
                     case PS3:
                         return "Select";
                     case PS4:
                     case PS5:
                         return "Share";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "-";
                     default:
                         return "Back";
                 }
             case GLFW.GLFW_GAMEPAD_BUTTON_START:
                 switch (controllerType) {
-                    case XBOXONE:
+                    case XBOX_ONE:
                         return "Menu";
                     case PS4:
                     case PS5:
                         return "Options";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "+";
                     default:
                         return "Start";
@@ -298,7 +298,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "L1";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "L";
                     default:
                         return "LB";
@@ -309,7 +309,7 @@ public class ControllerInput {
                     case PS4:
                     case PS5:
                         return "R1";
-                    case NINTENDO_SWITCH_PRO:
+                    case SWITCH:
                         return "R";
                     default:
                         return "RB";
diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerType.java b/src/main/java/net/minecraft/client/input/controller/ControllerType.java
index 399cc6eae..b59abd297 100644
--- a/src/main/java/net/minecraft/client/input/controller/ControllerType.java
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerType.java
@@ -1,51 +1,36 @@
 package net.minecraft.client.input.controller;
 
 import net.minecraft.client.input.glfw.GlfwGamepad;
-import java.util.Arrays;
-import java.util.List;
 
 public enum ControllerType {
-    UNKNOWN(Category.XBOX, "xbox", "UNKNOWN"),
-    XBOX360(Category.XBOX, "xbox", "XBOX 360"),
-    XBOXONE(Category.XBOX, "xbox", "XBOX ONE"),
-    PS3(Category.PLAYSTATION, "playstation", "PLAYSTATION 3"),
-    PS4(Category.PLAYSTATION, "playstation", "PLAYSTATION 4"),
-    PS5(Category.PLAYSTATION, "playstation", "PLAYSTATION 5"),
-    NINTENDO_SWITCH_PRO(Category.NINTENDO, "nintendo", "NINTENDO SWITCH PRO");
-
-    private final Category category;
+    UNKNOWN(Layout.XBOX, "xbox_360", "UNKNOWN"),
+    XBOX_360(Layout.XBOX, "xbox_360", "XBOX 360"),
+    XBOX_ONE(Layout.XBOX, "xbox_one", "XBOX ONE"),
+    PS3(Layout.PLAYSTATION, "ps3", "PLAYSTATION 3"),
+    PS4(Layout.PLAYSTATION, "ps4", "PLAYSTATION 4"),
+    PS5(Layout.PLAYSTATION, "ps5", "PLAYSTATION 5"),
+    SWITCH(Layout.NINTENDO, "switch", "NINTENDO SWITCH"),
+    STEAM(Layout.XBOX, "steam", "STEAM CONTROLLER"),
+    STEAM_DECK(Layout.STEAM_DECK, "steam_deck", "STEAM DECK"),;
+
+    private final Layout layout;
     private final String assetName;
     private final String printableName;
 
-    ControllerType(Category category, String assetName, String printableName) {
-        this.category = category;
+    ControllerType(Layout layout, String assetName, String printableName) {
+        this.layout = layout;
         this.assetName = assetName;
         this.printableName = printableName;
     }
 
     public static ControllerType fromController(GlfwGamepad controller) {
-        List<String> name = Arrays.asList(controller.getName().toLowerCase().split(" "));
-        if (name.contains("xbox") || name.contains("xinput")) {
-            if (name.contains("one")) {
-                return XBOXONE;
-            }
-            return XBOX360;
-        }
-        if ((name.contains("playstation") && name.contains("3")) || name.contains("ps3")) {
-            return PS3;
-        } else if ((name.contains("playstation") && name.contains("4")) || name.contains("ps4")) {
-            return PS4;
-        } else if ((name.contains("playstation") && name.contains("5")) || name.contains("ps5")) {
-            return PS5;
-        } else if (name.contains("nintendo") && name.contains("switch") && name.contains("pro")) {
-            return NINTENDO_SWITCH_PRO;
-        } else {
-            return UNKNOWN;
-        }
+        int vid = controller.getVendorId();
+        int pid = controller.getDeviceId();
+        return ControllerTypeDatabase.getControllerType(vid, pid);
     }
 
-    public Category getCategory() {
-        return this.category;
+    public Layout getLayout() {
+        return this.layout;
     }
 
     public String getAssetName() {
@@ -56,9 +41,10 @@ public enum ControllerType {
         return this.printableName;
     }
 
-    public enum Category {
+    public enum Layout {
         XBOX,
         PLAYSTATION,
-        NINTENDO;
+        NINTENDO,
+        STEAM_DECK
     }
 }
diff --git a/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java b/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java
new file mode 100644
index 000000000..d9702e1c1
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/controller/ControllerTypeDatabase.java
@@ -0,0 +1,78 @@
+package net.minecraft.client.input.controller;
+
+import java.io.BufferedReader;
+import java.io.InputStream;
+import java.io.InputStreamReader;
+import java.util.HashMap;
+import java.util.Map;
+
+public abstract class ControllerTypeDatabase {
+    private static Map<Integer, ControllerType> controllers = null;
+
+    public static ControllerType getControllerType(int vid, int pid) {
+        int combined = ((vid & 0xFFFF) << 16) | (pid & 0xFFFF);
+        if (controllers == null) {
+            init();
+        }
+        return controllers.getOrDefault(combined, ControllerType.UNKNOWN);
+    }
+
+    private static void init() {
+        controllers = new HashMap<>();
+
+        // Read controllers.csv
+        try (InputStream stream = ControllerTypeDatabase.class.getResourceAsStream("/controllers.csv")) {
+            if (stream != null) {
+                BufferedReader reader = new BufferedReader(new InputStreamReader(stream));
+                String line;
+                while ((line = reader.readLine()) != null) {
+                    if (line.startsWith("#")) {
+                        continue;
+                    }
+
+                    String[] parts = line.split(",");
+                    if (parts.length != 3) {
+                        continue;
+                    }
+
+                    if (parts[0].startsWith("0x")) {
+                        parts[0] = parts[0].substring(2);
+                    }
+                    if (parts[1].startsWith("0x")) {
+                        parts[1] = parts[1].substring(2);
+                    }
+                    int vid = Integer.parseInt(parts[0], 16);
+                    int pid = Integer.parseInt(parts[1], 16);
+                    int combined = ((vid & 0xFFFF) << 16) | (pid & 0xFFFF);
+                    controllers.put(combined, getControllerType(parts[2]));
+                }
+            }
+        } catch (Exception e) {
+            e.printStackTrace();
+            return;
+        }
+    }
+
+    private static ControllerType getControllerType(String id) {
+        switch (id) {
+            case "PS3Controller":
+                return ControllerType.PS3;
+            case "PS4Controller":
+                return ControllerType.PS4;
+            case "PS5Controller":
+                return ControllerType.PS5;
+            case "XBox360Controller":
+                return ControllerType.XBOX_360;
+            case "XBoxOneController":
+                return ControllerType.XBOX_ONE;
+            case "SwitchController":
+                return ControllerType.SWITCH;
+            case "SteamController":
+                return ControllerType.STEAM;
+            case "SteamDeckController":
+                return ControllerType.STEAM_DECK;
+            default:
+                return ControllerType.UNKNOWN;
+        }
+    }
+}
diff --git a/src/main/java/net/minecraft/client/input/controller/DigitalPad.java b/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
index 49ea31c1b..1ca4fac56 100644
--- a/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
+++ b/src/main/java/net/minecraft/client/input/controller/DigitalPad.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.input.controller;
 
-import net.java.games.input.Component;
-
 public class DigitalPad {
 	
 	public IButton up;
diff --git a/src/main/java/net/minecraft/client/input/controller/IButtonListener.java b/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
index 69168223d..4671abd83 100644
--- a/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
+++ b/src/main/java/net/minecraft/client/input/controller/IButtonListener.java
@@ -1,7 +1,5 @@
 package net.minecraft.client.input.controller;
 
-import net.java.games.input.Component;
-
 public interface IButtonListener {
 	
 	boolean isPressed(int button);
diff --git a/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java b/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java
new file mode 100644
index 000000000..a76eaa804
--- /dev/null
+++ b/src/main/java/net/minecraft/client/input/glfw/FakeGamepad.java
@@ -0,0 +1,65 @@
+package net.minecraft.client.input.glfw;
+
+public class FakeGamepad extends GlfwGamepad {
+    private final String name;
+    private final int vid;
+    private final int pid;
+
+    public FakeGamepad(int id, String name, int vid, int pid) {
+        super(id);
+
+        this.name = name;
+        this.vid = vid;
+        this.pid = pid;
+    }
+
+    @Override
+    public String getGuid() {
+        return "00000000000000000000000000000000";
+    }
+
+    @Override
+    public int getVendorId() {
+        return vid;
+    }
+
+    @Override
+    public int getDeviceId() {
+        return pid;
+    }
+
+    @Override
+    public void poll() {
+        return;
+    }
+
+    @Override
+    public boolean isPresent() {
+        return true;
+    }
+
+    @Override
+    public String getName() {
+        return name;
+    }
+
+    @Override
+    public float getAxisValue(int axis) {
+        return 0.0F;
+    }
+
+    @Override
+    public boolean isButtonPressed(int button) {
+        return false;
+    }
+
+    @Override
+    public int getHatValue(int hat) {
+        return 0;
+    }
+
+    @Override
+    public GlfwGamepad intoGamepad() {
+        return this;
+    }
+}
diff --git a/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java b/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java
index 31b2401f8..06f70a47b 100644
--- a/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java
+++ b/src/main/java/net/minecraft/client/input/glfw/GlfwJoystick.java
@@ -7,6 +7,8 @@ import java.nio.FloatBuffer;
 
 public class GlfwJoystick {
     private final int id;
+    private final int vid;
+    private final int did;
     private FloatBuffer axes = null;
     private ByteBuffer buttons = null;
     private ByteBuffer hats = null;
@@ -14,12 +16,53 @@ public class GlfwJoystick {
 
     public GlfwJoystick(int id) {
         this.id = id;
+
+        String guid = this.getGuid();
+
+        int vid = 0;
+        try {
+            String lower = guid.substring(8, 10);
+            String upper = guid.substring(10, 12);
+            vid = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + id + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        int did = 0;
+        try {
+            String lower = guid.substring(16, 18);
+            String upper = guid.substring(18, 20);
+            did = Integer.parseInt(upper + lower, 16);
+        } catch (Exception e) {
+            System.out.println("Controller " + id + " has weird GUID!");
+            this.vid = 0;
+            this.did = 0;
+            return;
+        }
+
+        this.vid = vid;
+        this.did = did;
     }
 
     public int getId() {
         return this.id;
     }
 
+    public String getGuid() {
+        return GLFW.glfwGetJoystickGUID(this.id);
+    }
+
+    public int getVendorId() {
+        return this.vid;
+    }
+
+    public int getDeviceId() {
+        return this.did;
+    }
+
     public void poll() {
         this.axes = GLFW.glfwGetJoystickAxes(this.id);
         this.buttons = GLFW.glfwGetJoystickButtons(this.id);
diff --git a/src/main/java/net/minecraft/client/option/GameSettings.java b/src/main/java/net/minecraft/client/option/GameSettings.java
index 9a34f85c1..2e8d9ee90 100644
--- a/src/main/java/net/minecraft/client/option/GameSettings.java
+++ b/src/main/java/net/minecraft/client/option/GameSettings.java
@@ -97,7 +97,6 @@ public class GameSettings {
 	public BooleanOption showChunkBorders = new BooleanOption(this, "showChunkBorders", false);
 	public BooleanOption showCollisionBoxes = new BooleanOption(this, "showCollisionBoxes", false);
 	public BooleanOption swapCraftingButtons = new BooleanOption(this, "swapCraftingButtons", false);
-	public BooleanOption disableJInput = new BooleanOption(this, "disableJInput", false);
     public BooleanOption forceUnicodeFont = new BooleanOption(this, "forceUnicodeFont", false);
 	public EnumOption<PlacementMode> placementMode = new EnumOption<>(this, "placementMode", PlacementMode.class, PlacementMode.DEFAULT).setIsSlider(false);
 	public BooleanOption discordRichPresence = new BooleanOption(this, "discordRichPresence", false);
@@ -126,7 +125,8 @@ public class GameSettings {
 	public BooleanOption enableItemClumping = new BooleanOption(this, "enableItemClumping", false);
 	public BooleanOption alwaysShowDescriptions = new BooleanOption(this, "alwaysShowDescriptions", false);
 	public BooleanOption turnWithVehicle = new BooleanOption(this, "turnWithVehicle", true);
-	public BooleanOption disableCrashHandler = new BooleanOption(this,"disableCrashHandler",false);
+	public BooleanOption disableCrashHandler = new BooleanOption(this, "disableCrashHandler", false);
+	public BooleanOption enableMultiDrawRendering = new BooleanOption(this, "enableMultiDrawRendering", true);
 
 	public BooleanOption enableDevResourceLoading = new BooleanOption(this, "enableDevResourceLoading", false);
 	public BooleanOption downloadSoundfiles = new BooleanOption(this, "downloadSoundfiles", true);
@@ -231,6 +231,7 @@ public class GameSettings {
 	public KeyBinding keyReleaseCursor = new KeyBinding("key.debug.releasecursor").setDefault(InputDevice.keyboard, KEY_F12);
 	public KeyBinding keyShowShortcuts = new KeyBinding("key.debug.shortcuts").setDefault(InputDevice.keyboard, KEY_Q);
 	public KeyBinding keyToggleTextureAtlas = new KeyBinding("key.debug.textureAtlas");
+	public KeyBinding keyLoadChunksQuickly = new KeyBinding("key.debug.loadChunksQuickly");
 
 	public static final List<KeyBinding> keys = new ArrayList<>();
 	public static final List<Option<?>> options = new ArrayList<>();
@@ -462,6 +463,9 @@ public class GameSettings {
 		if(option == customLightmap) {
 			mc.worldRenderer.lightmapHelper.setup();
 		}
+		if(option == rawMouseInput) {
+			mc.mouseInput.setRawInput(rawMouseInput.value);
+		}
 	}
 
 	public void loadOptions() {
diff --git a/src/main/java/net/minecraft/client/render/CameraSorter.java b/src/main/java/net/minecraft/client/render/CameraSorter.java
index 1a4c4a725..5dd7cfef5 100644
--- a/src/main/java/net/minecraft/client/render/CameraSorter.java
+++ b/src/main/java/net/minecraft/client/render/CameraSorter.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.terrain.ChunkRenderer;
 
 import java.util.Comparator;
 
diff --git a/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java b/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
index 86185a0e9..e5291eebd 100644
--- a/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
+++ b/src/main/java/net/minecraft/client/render/ChunkRendererComparator.java
@@ -1,6 +1,7 @@
 package net.minecraft.client.render;
 
 import net.minecraft.client.render.camera.ICamera;
+import net.minecraft.client.render.terrain.ChunkRenderer;
 
 import java.util.Comparator;
 
diff --git a/src/main/java/net/minecraft/client/render/OpenGLHelper.java b/src/main/java/net/minecraft/client/render/OpenGLHelper.java
index aed0371c0..6b545d69b 100644
--- a/src/main/java/net/minecraft/client/render/OpenGLHelper.java
+++ b/src/main/java/net/minecraft/client/render/OpenGLHelper.java
@@ -19,6 +19,8 @@ public class OpenGLHelper {
 	
 	public static boolean enableOcclusionCheck = false;
 	public static boolean enableSphericalFog = false;
+	public static boolean gl20 = false;
+	public static boolean gl31 = false;
 	
     public static void testCapabilities(Minecraft minecraft) {
         System.out.println(glGetString(GL_VERSION));
@@ -33,6 +35,8 @@ public class OpenGLHelper {
         
         enableOcclusionCheck = capabilities.GL_ARB_occlusion_query;
         enableSphericalFog = capabilities.GL_NV_fog_distance;
+        gl20 = capabilities.OpenGL20;
+        gl31 = capabilities.OpenGL31;
         
 		if(minecraft.gameSettings.disableShaders.value) {
 			Shaders.enableShaders = false;
diff --git a/src/main/java/net/minecraft/client/render/RenderGlobal.java b/src/main/java/net/minecraft/client/render/RenderGlobal.java
index 0289d6990..474a729ce 100644
--- a/src/main/java/net/minecraft/client/render/RenderGlobal.java
+++ b/src/main/java/net/minecraft/client/render/RenderGlobal.java
@@ -14,6 +14,7 @@ import net.minecraft.client.render.camera.EntityCamera;
 import net.minecraft.client.render.camera.ICamera;
 import net.minecraft.client.render.colorizer.Colorizers;
 import net.minecraft.client.render.culling.CameraFrustum;
+import net.minecraft.client.render.terrain.ChunkRenderer;
 import net.minecraft.client.render.texture.stitcher.IconCoordinate;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
@@ -74,7 +75,7 @@ public class RenderGlobal
         }
     }
     public static final int RENDER_CHUNK_SIZE = 16;
-    public static final int RENDER_LIST_BASE_WIDTH = 64;
+    public static final int RENDER_LIST_BASE_WIDTH = 48;
 
     public RenderGlobal(Minecraft minecraft, RenderEngine renderengine)
     {
@@ -231,10 +232,6 @@ public class RenderGlobal
             }
         }
         int renderDiameterBlocks = renderDistance.chunks * 16 * 2;
-        if (renderDiameterBlocks > 400)
-        {
-            renderDiameterBlocks = 400;
-        }
 		renderChunksWide = renderDiameterBlocks / RENDER_CHUNK_SIZE + 1;
         renderChunksTall = worldObj.getHeightBlocks() / RENDER_CHUNK_SIZE;
 		renderChunksDeep =  renderDiameterBlocks / RENDER_CHUNK_SIZE + 1;
@@ -262,7 +259,7 @@ public class RenderGlobal
                 for(int z = 0; z < renderChunksDeep; z++)
                 {
                     int index = (z * renderChunksTall + y) * renderChunksWide + x;
-                    chunkRenderers[index] = new ChunkRenderer(worldObj, tileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, glRenderListBase + renderListOffset);
+                    chunkRenderers[index] = mc.terrainRenderer.createChunkRenderer(worldObj, tileEntities, x * RENDER_CHUNK_SIZE, y * RENDER_CHUNK_SIZE, z * RENDER_CHUNK_SIZE, RENDER_CHUNK_SIZE, glRenderListBase + renderListOffset);
                     if(occlusionEnabled)
                     {
                         chunkRenderers[index].occlusionId = glOcclusionQueryBase.get(chunkIndex);
@@ -486,7 +483,7 @@ public class RenderGlobal
         return "E: " + countEntitiesRendered + "/" + countEntitiesTotal + ". B: " + countEntitiesHidden + ", I: " + (countEntitiesTotal - countEntitiesHidden - countEntitiesRendered);
     }
 
-    private void markRenderersForNewPosition(int i, int j, int k)
+    public void markRenderersForNewPosition(int i, int j, int k)
     {
         i -= 8;
         j -= 8;
